Public Class Form1
    ' Copy this text into the Label using hte biggest font that will fit.
    Private Sub txtSample_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtSample.TextChanged
        Dim txt As String = txtSample.Text

        ' Only bother if there's text.
        If txt.Length > 0 Then
            Dim best_size As Integer = 100

            ' See how much room we have, allowing a bit
            ' for the Label's internal margin.
            Dim wid As Integer = lblSample.DisplayRectangle.Width - 3
            Dim hgt As Integer = lblSample.DisplayRectangle.Height - 3

            ' Make a Graphics object to measure the text.
            Using gr As Graphics = lblSample.CreateGraphics()
                For i As Integer = 10 To 100
                    Using test_font As New Font(lblSample.Font.FontFamily, i)
                        ' See how much space the text would need,
                        ' specifying a maximum width.
                        Dim text_size As SizeF = gr.MeasureString( _
                            txt & "m", test_font)
                        If text_size.Width > wid OrElse text_size.Height > hgt Then
                            best_size = i - 1
                            Exit For
                        End If
                    End Using
                Next i
            End Using

            ' Use that font size.
            lblSample.Font = New Font(lblSample.Font.FontFamily, best_size)
        End If

        ' Display the text.
        lblSample.Text = txt
    End Sub
End Class
